<template>
    <div class="exportTable">

        <!-- ********** feuille projet ************ -->
        <table id="ProjetExportTable" class="resultable__table">
            <!-- ********** hors logic ************ -->
            <tr>
                <td>Nom du projet</td>
                <td>{{initialData.data.nomProjet}}</td>
            </tr>
            <tr>
                <td>Date d'export</td>
                <td>{{getDate()}}</td>
            </tr>
            <tr>
                <td>Durée de l'étude</td>
                <td>{{initialData.data.dureeEtude}}</td>
            </tr>
            <!-- *********** Commun ***************** -->
            <tr>
            </tr>
            <tr>
                <td></td>
                <td>SDP</td>
                <td>Eges</td>
                <td>Eges PCE</td>
                <td>Eges Max C1</td>
                <td>Eges PCE Max C1</td>
                <td>Eges Max C2</td>
                <td>Eges PCE Max C2</td>
            </tr>
            <tr v-for="value in getBatimentSdpEges()">
                <td>{{value.name}}</td>
                <td>{{value.sdp}}</td>
                <td>{{value.eges}}</td>
                <td>{{value.egesPCE}}</td>
                <td>{{value.egesMaxC1}}</td>
                <td>{{value.egesPCEMaxC1}}</td>
                <td>{{value.egesMaxC2}}</td>
                <td>{{value.egesPCEMaxC2}}</td>
            </tr>
            <tr>
            </tr>
            <!-- ******** in logic ************ -->
            <tr>
                <th></th>
                <th v-for="col in cols" class="contentRow"> {{ col }} </th>
            </tr>
            <tr>
                <th></th>
                <th v-for="col in cols" class="contentRow">Total cycle de vie</th>
            </tr>
            <tr>
                <td>Projet</td>
                <td class="contentRow" v-for="row in rowTransform(resultsProjet,'projet')">{{ row }}</td>
            </tr>
        </table>

        <!-- ********** feuille batiment ************ -->
        <table id="BatimentExportTable" class="exportTable">
            <tr>
                <td>Nom du projet</td>
                <td>{{initialData.data.nomProjet}}</td>
            </tr>
            <!-- *********** Commun ***************** -->
            <tr>
            </tr>
            <tr>
                <td></td>
                <td>SDP</td>
                <td>Eges</td>
                <td>Eges PCE</td>
                <td>Eges Max C1</td>
                <td>Eges PCE Max C1</td>
                <td>Eges Max C2</td>
                <td>Eges PCE Max C2</td>
            </tr>
            <tr v-for="value in getBatimentSdpEges()">
                <td>{{value.name}}</td>
                <td>{{value.sdp}}</td>
                <td>{{value.eges}}</td>
                <td>{{value.egesPCE}}</td>
                <td>{{value.egesMaxC1}}</td>
                <td>{{value.egesPCEMaxC1}}</td>
                <td>{{value.egesMaxC2}}</td>
                <td>{{value.egesPCEMaxC2}}</td>
            </tr>
            <tr>
            </tr>
             <!-- ******** in logic ************ -->
            <tr>
                <th v-for="n in getSpace('Batiment')"></th>
                <th v-for="col in cols" class="contentRow"> {{ col }} </th>
            </tr>
            <tr>
                <th v-for="n in getSpace('Batiment')"></th>
                <th v-for="col in cols" class="contentRow">Total cycle de vie</th>
            </tr>
            <tr v-for="(batiments,index) in resultsBatiment">
                <td v-for="name in getBatimentPathByNumber(index)">{{name}}</td>
                <td class="contentRow" v-for="row in rowTransform(batiments,'batiment')">{{ row }}</td>
            </tr>
        </table>

        <!-- ********** feuille batiment ************ -->
        <table id="ZoneExportTable" class="exportTable">
            <tr>
                <td>Nom du projet</td>
                <td>{{initialData.data.nomProjet}}</td>
            </tr>
            <!-- *********** Commun ***************** -->
            <tr>
            </tr>
            <tr>
                <td></td>
                <td>SDP</td>
                <td>Eges</td>
                <td>Eges PCE</td>
                <td>Eges Max C1</td>
                <td>Eges PCE Max C1</td>
                <td>Eges Max C2</td>
                <td>Eges PCE Max C2</td>
            </tr>
            <tr v-for="value in getBatimentSdpEges()">
                <td>{{value.name}}</td>
                <td>{{value.sdp}}</td>
                <td>{{value.eges}}</td>
                <td>{{value.egesPCE}}</td>
                <td>{{value.egesMaxC1}}</td>
                <td>{{value.egesPCEMaxC1}}</td>
                <td>{{value.egesMaxC2}}</td>
                <td>{{value.egesPCEMaxC2}}</td>
            </tr>
            <tr>
            </tr>
             <!-- ******** in logic ************ -->
            <tr>
                <th v-for="n in getSpace('Zone')"></th>
                <th v-for="col in cols" class="contentRow"> {{ col }} </th>
            </tr>
            <tr>
                <th v-for="n in getSpace('Zone')"></th>
                <th v-for="col in cols" class="contentRow">Total cycle de vie</th>
            </tr>
            <tr v-for="(zone,index) in resultsZone">
                <td v-for="name in getZonePathByNumber(index)">{{name}}</td>
                <td class="contentRow" v-for="row in rowTransform(zone,'zone')">{{ row }}</td>
            </tr>
        </table>

        <!-- ********** feuille batiment ************ -->
        <table id="ContributeurExportTable" class="exportTable">
            <tr>
                <td>Nom du projet</td>
                <td>{{initialData.data.nomProjet}}</td>
            </tr>
            <!-- *********** Commun ***************** -->
            <tr>
            </tr>
            <tr>
                <td></td>
                <td>SDP</td>
                <td>Eges</td>
                <td>Eges PCE</td>
                <td>Eges Max C1</td>
                <td>Eges PCE Max C1</td>
                <td>Eges Max C2</td>
                <td>Eges PCE Max C2</td>
            </tr>
            <tr v-for="value in getBatimentSdpEges()">
                <td>{{value.name}}</td>
                <td>{{value.sdp}}</td>
                <td>{{value.eges}}</td>
                <td>{{value.egesPCE}}</td>
                <td>{{value.egesMaxC1}}</td>
                <td>{{value.egesPCEMaxC1}}</td>
                <td>{{value.egesMaxC2}}</td>
                <td>{{value.egesPCEMaxC2}}</td>
            </tr>
            <tr>
            </tr>
             <!-- ******** in logic ************ -->
            <tr>
                <th v-for="n in getSpace('Contributeur')"></th>
                <th v-for="col in referenceNameList" class="contentRow"> {{ col }} </th>
            </tr>
            <tr>
                <th v-for="n in getSpace('Contributeur')"></th>
                <th v-for="col in referenceNameList" class="contentRow">Total cycle de vie</th>
            </tr>
            <tr v-for="(contributeur,index) in resultsContributeur">
                <td v-for="name in getContributeurPathByNumber(index)">{{name}}</td>
                <td class="contentRow" v-for="row in rowTransform(contributeur,'contributeur')">{{ row }}</td>
            </tr>
        </table>

        <table id="Total" class="exportTable">
            <tr>
                <th></th>
                <th v-for="col in totalCols"> {{ col }} </th>
            </tr>
            <div v-for="(leparam, indexValue) in Allvalues">
                <tr></tr><tr><td>{{getDescriptionFromValueIndex(indexValue)}}</td></tr><tr></tr>
                <tr v-for="(row, idx) in leparam">
                    <th >
                        {{ row.key + " [" + row.values[0].value.unit + "]"}}
                    </th>
                    <th v-for="col in rowTransformTotal(row.values)">
                        {{ col }}
                    </th>
                </tr>
            </div>
        </table>

    </div>
</template>

<script>

    import { referenceName, formatColonneNormeName } from "@/views/evaluation/scripts/calcNameNorme.js";
    import { egesGlobalMax, egesPCEMax, getEgesS, getEges, getEgesPCE } from "@/views/evaluation/scripts/calcEges.js"
    import { getIndicsExport, getIndics, getIndicsExportContrib } from "@/views/evaluation/scripts/calcIndicateur.js";

    export default {
        name: "hiddenExport",
        data() {
            return {
                resultsProjet: {
                    type: Array
                },
                resultsBatiment: {
                    type: Array
                },
                resultsZone: {
                    type: Array
                },
                resultsContributeur: {
                    type: Array
                },
                selectedIndex:0,
                Allvalues: [],
            }
        },
        props: {
            initialData: {
              type: Object
            },
            inputVal: {
                type:Array
            },
            shoudRecalculate: {
                type: Boolean
            },
            dvt: null
        },
        mounted: function(){
            this.resultsProjet = getIndicsExport(this.initialData, this.dvt, 'Projet');
            this.resultsBatiment = getIndicsExport(this.initialData, this.dvt, 'Bâtiment');
            this.resultsZone = this.formatResult(getIndicsExport(this.initialData, this.dvt, 'Zone'));
            this.resultsContributeur = this.formatResult(this.getResultContributeur(this.initialData, this.dvt));
            this.Allvalues = this.sortGetAllValues(this.getAllValues(this.dvt));
            this.getBatimentSdpEges();
        },
        computed: {
            /* GLOBAL FONCTION */
            cols: function () {
                if(!this.resultsProjet || !(this.resultsProjet instanceof Array)){return []};
                return this.resultsProjet.map( (item) => item.key);
            },
            totalCols: function () {
                let formateName = formatColonneNormeName();
                let idListe = this.getColumnsId();

                let test = idListe.map( (index) => {
                    return formateName[index]
                });

                return test;
            },
            values: function () {
                let accumulateur= [];
                for (var i = 0; i < this.inputVal.length; i++) {
                    for (var j = 0; j < this.inputVal[i].values.length; j++) {
                        accumulateur.push(this.inputVal[i].values[j]);
                    }
                }
                return accumulateur;
                //return this.inputVal[this.selectedIndex].values;
            },
            referenceNameList: function(){
                return referenceName;
            }
        },

        methods: {
            /**************** global fonction *************/
            getDate(){
                let ladate = new Date();
                let options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' };

                return ladate.toLocaleDateString('fr-FR', options);
            },

            getBatimentName(){
                let batiments = this.initialData.children;
                let batimentName = batiments.map( (batiment,index) => batiment.description || 'Bâtiment '+(index+1) );
                return batimentName;
            },

            getSpace: function(value){
                switch (value){
                    case 'Projet': return new Array(1);
                    case 'Batiment': return new Array(2);
                    case 'Zone': return new Array(3);
                    case 'Contributeur': return new Array(4);
                }
            },

            getBatimentPathByNumber(batimentNumber){
                if (!Number.isInteger(batimentNumber))
                    return [];
                let tmp = ['Projet'];
                let lebatiment = this.initialData.children[batimentNumber];
                let batimentName = lebatiment.description || lebatiment.name+(batimentNumber+1);
                return tmp.concat([batimentName]);
            },

            getZonePathByNumber(zoneNumber){
                if (!Number.isInteger(zoneNumber))
                    return [];

                for (var i = 0; i < this.initialData.children.length; i++) {

                    let batiment = this.initialData.children[i];
                    if(batiment.children.length > zoneNumber){
                        let batimentName = batiment.description || batiment.name+(i+1);
                        let zone = batiment.children[zoneNumber];
                        let zoneName = zone.description || zone.name+(zoneNumber+1);
                        return ['Projet',batimentName,zoneName];
                    }
                    else{
                        zoneNumber -= batiment.children.length;
                    }
                }

            },

            getContributeurPathByNumber(contributeurNumber){
                if (!Number.isInteger(contributeurNumber)){
                    return [];
                }

                let ContributeurList = ['Contributeur PCE','Contributeur Energie','Contributeur Eau','Contributeur Chantier'];
                let nbZoneParcourue = 0

                let zone = contributeurNumber 
                for (let i = 0; i < this.initialData.children.length; i++) {
                    let batiment = this.initialData.children[i];
                    for (let j = 0; j < batiment.children.length; j++) {
                        nbZoneParcourue++;
                        let currentStartIndex = nbZoneParcourue*4;//4 contributeur par zone
                        if(currentStartIndex > contributeurNumber){
                            let batimentName = batiment.description || batiment.name+(i+1);
                            let zone = batiment.children[j];
                            let zoneName = zone.description || zone.name+(j+1);
                            return ['Projet',batimentName,zoneName, ContributeurList[contributeurNumber%4]]
                        }

                    }
                }

            },

            formatResult(array){
                if(!array){
                    return [];
                }
                let returnArray = [];
                array.map( (object) => {
                    for (var i = 0; i < object.length; i++) {
                        returnArray.push(object[i]);
                    }
                })
                return returnArray;
            },

            TransformContrib(item){

            },

            getResultContributeur(newVal, dvt){
                let filter = "Contributeur PCE";
                let filterEnergie = "Contributeur Energie";
                let filterEau = "Contributeur Eau";
                let filterChantier = "Contributeur Chantier";

                let returnArray = [];

                for (let i = 0; i < newVal.children.length; i++) {
                    let batiment = newVal.children[i];
                    for (let j = 0; j < batiment.children.length; j++) {
                        let zone = batiment.children[j];

                        let a = this.sortAndComplete(getIndicsExportContrib(newVal, dvt, filter));
                        let b = this.sortAndComplete(getIndicsExportContrib(newVal, dvt, filterEnergie));
                        let c = this.sortAndComplete(getIndicsExportContrib(newVal, dvt, filterEau));
                        let d = this.sortAndComplete(getIndicsExportContrib(newVal, dvt, filterChantier));
                        returnArray.push([a,b,c,d]);
                    }
                }
                return returnArray
            },

            /**************** SDP EGES fonction *************/
            getBatimentSdpEges(){
                let batimentsName = this.getBatimentName();
                let batimentSdgEges = batimentsName.map((batiment,index) => {

                    let sdpBatiment = this.getSdpBatiment(index);
                    let valEGES = getEges(this.initialData.children[index], this.dvt);
                    let valEgesPCE = getEgesPCE(this.initialData.children[index], this.dvt);
                    let egesMax = this.getEgesMaxBatiment(index);
                    let egesPCEMax = this.getEgesMaxPCeBatiment(index);

                    return {
                        'name': batiment,
                        'sdp': sdpBatiment,
                        'eges': valEGES,
                        'egesPCE': valEgesPCE,
                        'egesMaxC1':egesMax[0],
                        'egesPCEMaxC1':egesPCEMax[0],
                        'egesMaxC2':egesMax[1],
                        'egesPCEMaxC2':egesPCEMax[1],
                    }
                });
                return batimentSdgEges;
            },

            getSdpBatiment(index){
                let batimentData = this.initialData.children[index].data;
                return batimentData.sdpZone || 'NON RENSEIGNE';
            },

            getEgesMaxBatiment(index){
                if(!this.initialData.data.dep || !this.initialData.data.alt){return 0;}
                return egesGlobalMax(this.initialData.children[index].data, this.initialData.data.dep, this.initialData.data.alt, getEgesS(this.initialData.children[index]));
            },

            getEgesMaxPCeBatiment(index){
                if(!this.initialData.data.dep || !this.initialData.data.alt){return 0;}
                return egesPCEMax(this.initialData.children[index].data, this.initialData.data.dep, this.initialData.data.alt);
            },

            /*********** Calcul Fonction **********/
            rowTransform: function(rows,label) {
                if(!rows || !(rows instanceof Array)){return []};
                return rows.map( (item) => {
                    return item.value.sum.toExponential(2);
                });
            },
            rowTransformTotal: function(rows) {
                let idListe = this.getColumnsId();
                let value = rows.map( (item) => item.key)


                let yolo = rows.reduce((obj, item) => {
                             obj[item['key']] = item
                             return obj
                           }, {})


                let valueFormat = [];


                idListe.forEach( function(index){
                    if(value.indexOf(index) !== -1){
                        valueFormat.push(yolo[index].value.sum);
                    }
                    else{
                        valueFormat.push('');
                    }
                })

                return valueFormat;
            },
            getColumnsId(){
                let idListe = []
                for (var i = 0; i < this.inputVal.length; i++) {
                    let values = this.inputVal[i];
                    if(!values){
                        return [];
                    }
                    values.values.map((tmp) => {
                        return tmp.values.map( (yolo) => {
                            if(idListe.indexOf(yolo.key) === -1){
                                idListe.push(yolo.key);
                            }
                        });
                    });
                }
                return idListe;
            },
            getAllValues(ladvt){
                let returnArray = [];
                returnArray.push(getIndics(this.initialData, ladvt));

                for (var i = 0; i < this.initialData.children.length; i++) {
                    let batiment = this.initialData.children[i];
                    returnArray.push(getIndics(batiment,ladvt));

                    for (var j = 0; j < batiment.children.length; j++) {
                        let zone = batiment.children[j];
                        returnArray.push(getIndics(zone, ladvt));

                        for (var k = 0; k < zone.children.length; k++) {
                            let contributeur = zone.children[k]
                            returnArray.push(getIndics(contributeur, ladvt))
                        }

                    }

                }
                return returnArray;
            },
            sortGetAllValues(notSortedValue){
                let sortedArray = notSortedValue.map( (arrayListOfValue) => {
                    let concatArray = [];
                    for (var i = 0; i < arrayListOfValue.length; i++) {
                        let tmp = arrayListOfValue[i].values;                       
                        for (var j = 0; j < tmp.length; j++) {
                            concatArray.push(tmp[j]);
                        }
                    }
                    return concatArray;
                    
                })
                return sortedArray;
            },
            getDescriptionFromValueIndex(index){
                //la logique est assez sale. On réduit l'index jusqu'a zero. Lorsqu'il arrive a zero, c'est que c'est le niveau ou l'on est

                let ContributeurList = ['Contributeur PCE','Contributeur Energie','Contributeur Eau','Contributeur Chantier'];
                if(index === 0){
                    return 'Projet'
                }
                index--;
                for (var i = 0; i < this.initialData.children.length; i++) {
                    let batiment = this.initialData.children[i];
                    if( index === 0){
                        return batiment.description || batiment.name+(i+1);
                    }
                    index--;
                    for (var j = 0; j < batiment.children.length; j++) {
                        let zone = batiment.children[j];
                        if(index ===0){
                            return ''+ (batiment.description || batiment.name+(i+1) )+ ' - ' + (zone.description || zone.name+(j+1));
                        }
                        index--;
                        for (var k = 0; k < ContributeurList.length; k++) {
                            if(index === 0 ){
                                return ''+ (batiment.description || batiment.name+(i+1) )+ ' - ' + (zone.description || zone.name+(j+1)) + ' - ' + ContributeurList[k];
                            }
                            index--;
                        }

                    }

                }
            },
            sortAndComplete(array){
                let tmpArray;

                if(array.length !== 26){
                    tmpArray = this.completeArray(array);
                }
                else{
                    tmpArray = array;
                }

                tmpArray.sort( function(a,b){
                    let indexA = referenceName.indexOf(a.key);
                    let indexB = referenceName.indexOf(b.key);

                    return indexA > indexB ? 1 : -1;

                });

                return tmpArray;

            },
            completeArray(array){
                let keyArray = array.map( item => item.key);

                referenceName.map( (name) => {
                    if(keyArray.indexOf(name) === -1){
                        array.push({
                            'key': name,
                            'value': {
                                'sum': 0, 
                                'unit': '', 
                                'indicID': 0
                            }
                        });
                    }
                })

                return array;
            }
        }
    };
</script>

<style scoped>
    .exportTable{
        display: none;
    }
</style>
